<?php
/**
  * This file is the basic core engine for right management of plugins
  * in DynPG.
  *
  *
  * @package DynPG PlugIn Engine
  * @author Daniel Schliebner
  *
  * (c) 2011 Daniel Schliebner
  */

define('DPGPLUGINS_RIGHT_DEFAULT', 0);

class dynpgPluginRights {

    // all available plugins
    var $plugins;

    // all available plugin rights
    var $rights;

    function dynpgPluginRights() {
        // read all plugins
        $this->plugins = dynpg_handle_plugins('handle', false, false);
    }

    function read($plugin_name = false) {
        $iterator = $plugin_name === false? $this->plugins: Array($plugin_name);

        // read additional rights for the plugins
        foreach ($iterator as $plugin) {
            if (empty($this->rights[$plugin]))
                $this->rights[$plugin] = Array(
                    DPGPLUGINS_RIGHT_DEFAULT => $GLOBALS['lang_dpg']->str['lang_rights_right_p0']
                );

            if (file_exists(dirname(__FILE__) . '/' . $plugin . '/' . 'pluginrights.php')) {
                require_once dirname(__FILE__) . '/' . $plugin . '/' . 'pluginrights.php';
                if (function_exists('callback_DynPG_PlugIn_Rights_' . strtolower($plugin))) {
                    $rights = call_user_func('callback_DynPG_PlugIn_Rights_' . strtolower($plugin));
                    if (is_array($rights)) {
                        if (isset($rights[DPGPLUGINS_RIGHT_DEFAULT]))
                            unset($rights[DPGPLUGINS_RIGHT_DEFAULT]);
                        $this->rights[$plugin] = array_merge($this->rights[$plugin], $rights);
                    }
                }
            }

            ksort($this->rights[$plugin]);
        }

        return $plugin_name === false? $this->rights: $this->rights[$plugin_name];
    }

    static function user_has_right($plugin, $right_bit = DPGPLUGINS_RIGHT_DEFAULT) {
        if (!VerifyAccess())
            false;
        $res = mysql_query("SELECT * FROM `dynpg_cms_plugin_rights` WHERE `user_id_fk` = '".mysql_real_escape_string($_SESSION['ID'])."' AND `plugin` = '".mysql_real_escape_string($plugin)."'");
        if (!mysql_num_rows($res))
            return false;
        $row = mysql_fetch_assoc($res);
        return (substr($row['right_bin'], $right_bit, 1) == 1);
    }
}



// EOF